/*
 * @(#)piacal.h	1.63   3/10/94
 * Function declarations and macros for piacal.c and oldpia.c
 */

#ifndef __PIACAL_H
#define __PIACAL_H

#if !defined(NO_PROTOTYPE) | defined(__cplusplus)
int    piacal   ( WORKERDATA *workerdata, PIAPARMS *piaparms,
   PIADATA *piadata, Lawchg *lawchgdata );
int    qcreqcal ( PIADATA *piadata );
int    oldpia   ( WORKERDATA *workerdata, PIAPARMS *piaparms,
   PIADATA *piadata, enum pia_type method );
int    cpibas   ( WORKERDATA *workerdata, PIAPARMS *piaparms,
   PIADATA *piadata, Lawchg *lawchgdata, int i22, int freeze,
   enum pia_type method, double *piasub, double *mfbsub, double amesub );
int    pl1972   ( WORKERDATA *, PIAPARMS *, double *, double *, int );
float  z4set    ( WORKERDATA *workerdata, PIADATA *piadata, Lawchg *lawchgdata );
int    i49cal1  ( PIADATA *piadata, Lawchg *lawchgdata );
int    i49cal2  ( PIADATA *piadata, Lawchg *lawchgdata );
void   trguarlc ( WORKERDATA *workerdata, PIADATA *piadata,
   Lawchg *lawchgdata, int itrans );
void   bpcal    ( PIAPARMS *piaparms, Lawchg *lawchgdata, int melgyr,
                  double *mbendpia );
void   percal   ( Lawchg *lawchgdata, int melgyr, double *mpercp );
void   factcal  ( PIAPARMS *piaparms, Lawchg *lawchgdata );
#else
int    piacal();
int    qcreqcal();
int    oldpia();
int    cpibas();
int    pl1972();
float  z4set();
int    i49cal1();
int    i49cal2();
void   trguarlc();
void   bpcal();
void   percal();
void   factcal();
#endif

#endif
